/**
 * Create Object of Pusheo : Normal Mode
 */
var pusheo = new Pusheo({
    publish_key: "123",
    subscribe_key: "123",
    url: "http://SERVER_IP:8080/pusheo/"
});

/**
 * Subscribe ONLY mode. Publishing is disabled. Only history call allowed.
 */
var pusheoObject = new Pusheo({
    subscribe_key: "123",
    url: "http://SERVER_IP:8080/pusheo/"
});

/**
 * Publish ONLY mode.
 */
var pusheo = new Pusheo({
    publish_key: "123",
    url: "http://SERVER_IP:8080/pusheo/"
});


/**
 * Subscribe to channel 12345
 * history_interval runs the history call after every 10 seconds
 */
pusheo.subscribe({
    channel: "12345",
    lost_messages_call: true,
    lost_messages_call_interval: 10000,
    open: connectionOpen,
    message: messageRecieved,
    message_sent: messageSent,
    close: connectionClose,
    error: onError,
    params: {
        timeout: 300000,
        transport: 'websocket',
        fallbackTransport: 'long-polling',
        maxRequest: 5000,
        reconnect: true,
        reconnectInterval: 5000
    }
});

/**
 * Publish message
 */
pusheo.publish({
    channel: "555444",
    message: "Hello!"
});

/**
 * 50 latest messages will be returned from the server with timestamps.
 */
pusheo.history({
    channel: "12345",
    limit: "50",
    returnTimestamp: true,
    callback: recievedHistory
});

/**
 * Retieves old messages after the given timestamp
 */
pusheo.history({
    channel: "12345",
    returnTimestamp: true,
    timestamp: 1376577675622,
    callback: recievedHistory
});


/**
 * Callback functions
 */
function connectionOpen(response) {
    alert("Connection opened");
}
function messageRecieved(response) {
    alert("Message recieved!");
}
function messageSent(response) {
    alert("Message Sent!");
}
function connectionClose(response) {
    alert("Connection closed");
}

function onError(response) {
    alert("Error");
}
function recievedHistory(data) {
    alert("Recieved History");
}
/**
 * Callback functions end
 */