<?php

class Pusheo {

    private $PUBLISH_KEY = '';
    private $SUBSCRIBE_KEY = '';
    private $URL = '';

    function Pusheo($publish_key, $subscribe_key, $URL) {

        $this->PUBLISH_KEY = $publish_key;
        $this->SUBSCRIBE_KEY = $subscribe_key;

        $lastChar = substr($URL, -1);
        if (!($lastChar === "/"))
            $URL .="/";

        $this->URL = $URL;
    }

    function subscribe($options) {
        $r = "<script type=\"text/javascript\" src=\"http://localhost/cometlib/javascript/jQuery-1.10.2.js\"></script>\n";
        $r .= "<script type=\"text/javascript\" src=\"http://localhost/cometlib/javascript/pusheo.js\"></script>\n";

        $initOptions = array();
        $initOptions['url'] = $this->URL;
        $initOptions['publish_key'] = $this->PUBLISH_KEY;
        $initOptions['subscribe_key'] = $this->SUBSCRIBE_KEY;

        $r .= "<script type=\"text/javascript\">";
        $r .= "var cs = new Pusheo(" . json_encode($initOptions) . ");";
        $r .= "cs.subscribe({"
                . "channel:".$options['channel']
                . ",open:".$options['open']
                . ",message:".$options['message']
                . ",message_sent:".$options['message_sent']
                . ",close:".$options['close']
                . ",error:".$options['error']
                . ",lost_messages_call:".$options['lost_messages_call']
                . ",lost_messages_call_interval:".$options['lost_messages_call_interval']
                ."});";
        $r .= "</script>";

        return $r;
    }

    function publish($args) {

        if (!($args['channel'] && $args['message'])) {
            echo('Missing Channel or Message');
            return false;
        }

        $publish_url = $this->URL . 'publish/' . $this->PUBLISH_KEY . "/" . $this->SUBSCRIBE_KEY . "/0/" . $args['channel'] . "/0/" . rawurlencode(json_encode($args['message']));

        return $this->_request($publish_url);
    }

    function history($args) {

        if (!$args['channel']) {
            echo('Missing Channel');
            return false;
        }

        $history_url = $this->URL . 'history/' . $this->SUBSCRIBE_KEY . "/" . $args['channel'] . "/0/";

        if (array_key_exists('limit', $args)) {
            $limit = +$args['limit'] ? +$args['limit'] : 50;
            $history_url .= strval($limit);
        } else {
            echo "Missing limit";
            return false;
        }

        $history = json_decode($this->_request($history_url), true);
        return $history;
    }

    function time() {

        $time_url = $this->URL . 'time';
        return _request($time_url);
    }

    private function _request($url) {

        $ch = curl_init($url);

        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $res = curl_exec($ch);
        curl_close($ch);

        return $res;
    }

}

?>