//  Pusheo
//
//  Created by Inscripts on 19/03/15.
//  Copyright (c) 2015 inscripts. All rights reserved.

#import <Foundation/Foundation.h>
#import "PusheoSocket.h"

@class Pusheo;
@protocol PusheoDelegate <NSObject>

- (void) onOpen;
- (void) onClose;
- (void) onMessage: (NSString *) message;
- (void) onMessageSent: (NSString *)message;
- (void) onError: (NSError *) reason;
- (void) onHistoryReceived: (NSString *)history;

@end

@interface Pusheo : NSObject <PusheoSocketDelegate>
@property (nonatomic, assign) id <PusheoDelegate> pusheoDelegate;

- (void) initializeWithServerUrl: (NSString *)url publishKey:(NSString *)publishKey subscribeKey:(NSString *) subscribeKey;
- (void) subscribe: (NSString *)channel;
- (void) periodicHistoryCall:(BOOL)periodicHistory interval:(int)intervalInSec;
- (void) publish: (NSString *)channel message:(NSString *)message;
- (void) historyForChannel:(NSString *)channel type:(NSString *)type limit:(NSString *)limit timestamp:(NSString *)timestamp returnTimestamp:(BOOL)returnTimestamp;
- (void) unsubscribe;

@end